# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class LiveVideoResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'rtmp_url': 'str',
        'stream_key': 'str',
        'save_replay': 'bool'
    }

    attribute_map = {
        'rtmp_url': 'rtmpUrl',
        'stream_key': 'streamKey',
        'save_replay': 'saveReplay'
    }

    def __init__(self, rtmp_url=None, stream_key=None, save_replay=None, local_vars_configuration=None):  # noqa: E501
        """LiveVideoResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._rtmp_url = None
        self._stream_key = None
        self._save_replay = None
        self.discriminator = None

        if rtmp_url is not None:
            self.rtmp_url = rtmp_url
        if stream_key is not None:
            self.stream_key = stream_key
        if save_replay is not None:
            self.save_replay = save_replay

    @property
    def rtmp_url(self):
        """Gets the rtmp_url of this LiveVideoResponse.  # noqa: E501


        :return: The rtmp_url of this LiveVideoResponse.  # noqa: E501
        :rtype: str
        """
        return self._rtmp_url

    @rtmp_url.setter
    def rtmp_url(self, rtmp_url):
        """Sets the rtmp_url of this LiveVideoResponse.


        :param rtmp_url: The rtmp_url of this LiveVideoResponse.  # noqa: E501
        :type rtmp_url: str
        """

        self._rtmp_url = rtmp_url

    @property
    def stream_key(self):
        """Gets the stream_key of this LiveVideoResponse.  # noqa: E501

        RTMP stream key to use to stream into this live video  # noqa: E501

        :return: The stream_key of this LiveVideoResponse.  # noqa: E501
        :rtype: str
        """
        return self._stream_key

    @stream_key.setter
    def stream_key(self, stream_key):
        """Sets the stream_key of this LiveVideoResponse.

        RTMP stream key to use to stream into this live video  # noqa: E501

        :param stream_key: The stream_key of this LiveVideoResponse.  # noqa: E501
        :type stream_key: str
        """

        self._stream_key = stream_key

    @property
    def save_replay(self):
        """Gets the save_replay of this LiveVideoResponse.  # noqa: E501


        :return: The save_replay of this LiveVideoResponse.  # noqa: E501
        :rtype: bool
        """
        return self._save_replay

    @save_replay.setter
    def save_replay(self, save_replay):
        """Sets the save_replay of this LiveVideoResponse.


        :param save_replay: The save_replay of this LiveVideoResponse.  # noqa: E501
        :type save_replay: bool
        """

        self._save_replay = save_replay

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LiveVideoResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LiveVideoResponse):
            return True

        return self.to_dict() != other.to_dict()
